'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var React = require('react');
var classnames = require('classnames');
var typography = require('@highlight-ui/typography');
var utilsCommons = require('@highlight-ui/utils-commons');
var icon = require('@highlight-ui/icon');
var tooltip = require('@highlight-ui/tooltip');
var input = require('@highlight-ui/input');
var utilsHooks = require('@highlight-ui/utils-hooks');
var select = require('@highlight-ui/select');
function _interopDefaultLegacy(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    'default': e
  };
}
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __rest(s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}
var styles$6 = {
  "horizontalFormField": "HorizontalFormField-module__myzUZuZQ__v5-4-62",
  "head": "HorizontalFormField-module__gsUtslNo__v5-4-62",
  "field": "HorizontalFormField-module__XlUwbuK7__v5-4-62",
  "validations": "HorizontalFormField-module__5W6Ekyt9__v5-4-62",
  "tooltipContent": "HorizontalFormField-module__Bcugbben__v5-4-62"
};
var styles$5 = {
  "labelContainer": "Label-module__NGRSZuBR__v5-4-62",
  "label": "Label-module__7PGRkV9n__v5-4-62",
  "labelTooltipIcon": "Label-module__cQ-uGnUZ__v5-4-62",
  "hintText": "Label-module__YTw7wAe1__v5-4-62"
};
var Label = function (_a) {
  var label = _a.label,
    tooltipContent = _a.tooltipContent,
    tooltipMouseOutDelay = _a.tooltipMouseOutDelay,
    htmlFor = _a.htmlFor,
    hintText = _a.hintText;
  return React__default["default"].createElement("div", {
    className: styles$5.labelContainer
  }, React__default["default"].createElement(typography.Typography, __assign({
    className: styles$5.label,
    token: "form-label",
    component: "label"
  }, htmlFor ? {
    htmlFor: htmlFor
  } : {}), label), tooltipContent && React__default["default"].createElement(tooltip.Tooltip, {
    content: tooltipContent,
    mouseOutDelay: tooltipMouseOutDelay,
    metadata: {
      testId: 'form-field-label-tooltip-icon'
    }
  }, React__default["default"].createElement("span", null, React__default["default"].createElement(icon.Icon, {
    className: styles$5.labelTooltipIcon,
    name: "info-circle",
    color: "icon-default",
    type: "solid",
    size: 14
  }))), hintText && React__default["default"].createElement(typography.Typography, {
    token: "caption",
    className: styles$5.hintText,
    component: "span"
  }, "(", hintText, ")"));
};
var styles$4 = {
  "validations": "Validations-module__9UkiOjPl__v5-4-62"
};
var styles$3 = {
  "validationStatusIcon": "ValidationMessage-module__IK9-Ul8V__v5-4-62",
  "validationMessage": "ValidationMessage-module__72bmawQj__v5-4-62"
};
var validationStatusesIconProps = {
  validating: {
    name: 'spinner-third',
    color: 'icon-highlight',
    spin: true
  },
  valid: {
    name: 'check-circle',
    color: 'icon-success'
  },
  invalid: {
    name: 'exclamation-circle',
    color: 'icon-critical'
  },
  warning: {
    name: 'exclamation-triangle',
    color: 'icon-warning'
  }
};
var ValidationMessage = function (_a) {
  var className = _a.className,
    message = _a.message,
    status = _a.status,
    metadata = _a.metadata;
  var validationStatusIconProps = validationStatusesIconProps[status];
  return React__default["default"].createElement("span", __assign({
    className: className
  }, utilsCommons.parseMetadata(metadata)), React__default["default"].createElement(icon.Icon, __assign({
    className: styles$3.validationStatusIcon,
    name: validationStatusIconProps.name,
    color: validationStatusIconProps.color,
    spin: validationStatusIconProps.spin,
    type: "solid",
    size: 12
  }, (metadata === null || metadata === void 0 ? void 0 : metadata.testId) && {
    metadata: {
      testId: (metadata === null || metadata === void 0 ? void 0 : metadata.testId) + "-icon"
    }
  })), React__default["default"].createElement(typography.Typography, {
    className: styles$3.validationMessage,
    token: "body-base",
    component: "span"
  }, message));
};
var Validations = function (_a) {
  var id = _a.id,
    className = _a.className,
    validations = _a.validations;
  return React__default["default"].createElement("div", {
    id: id,
    className: classnames__default["default"](styles$4.validations, className)
  }, validations && validations.length > 0 && React__default["default"].createElement(React__default["default"].Fragment, null, validations.map(function (validation) {
    return React__default["default"].createElement(ValidationMessage, {
      key: validation.key,
      message: validation.message,
      status: validation.status,
      metadata: validation.metadata
    });
  })));
};
var HorizontalFormField = function (_a) {
  var className = _a.className,
    children = _a.children,
    label = _a.label,
    htmlFor = _a.htmlFor,
    labelTooltipContent = _a.labelTooltipContent,
    labelTooltipMouseOutDelay = _a.labelTooltipMouseOutDelay,
    helperText = _a.helperText,
    hintText = _a.hintText,
    metadata = _a.metadata,
    validations = _a.validations,
    validationsId = _a.validationsId;
  var tooltipText = (helperText || labelTooltipContent) && React__default["default"].createElement(React__default["default"].Fragment, null, helperText && React__default["default"].createElement(typography.Typography, {
    token: "body-base",
    className: styles$6.tooltipContent
  }, helperText), helperText && labelTooltipContent && React__default["default"].createElement("br", null), labelTooltipContent && React__default["default"].createElement(typography.Typography, {
    token: "body-base",
    className: styles$6.tooltipContent
  }, labelTooltipContent));
  return React__default["default"].createElement("div", __assign({
    className: classnames__default["default"](styles$6.horizontalFormField, className)
  }, utilsCommons.parseMetadata(metadata)), React__default["default"].createElement("div", {
    className: styles$6.head
  }, React__default["default"].createElement(Label, __assign({
    label: label,
    tooltipContent: tooltipText,
    tooltipMouseOutDelay: labelTooltipMouseOutDelay
  }, htmlFor ? {
    htmlFor: htmlFor
  } : {})), hintText && React__default["default"].createElement(typography.Typography, {
    token: "caption",
    component: "span"
  }, hintText)), React__default["default"].createElement("div", {
    className: styles$6.field
  }, children), React__default["default"].createElement(Validations, {
    id: validationsId,
    validations: validations,
    className: styles$6.validations
  }));
};
var styles$2 = {
  "helperText": "HelperText-module__TVtnQ4nV__v5-4-62"
};
var HelperText = function (_a) {
  var text = _a.text;
  return React__default["default"].createElement(typography.Typography, {
    token: "body-base",
    className: styles$2.helperText,
    component: "span"
  }, text);
};
var styles$1 = {
  "formField": "FormField-module__j-Q948X2__v5-4-62"
};
var VerticalFormField = function (_a) {
  var className = _a.className,
    children = _a.children,
    label = _a.label,
    htmlFor = _a.htmlFor,
    labelTooltipContent = _a.labelTooltipContent,
    labelTooltipMouseOutDelay = _a.labelTooltipMouseOutDelay,
    helperText = _a.helperText,
    hintText = _a.hintText,
    metadata = _a.metadata,
    validationsId = _a.validationsId,
    validations = _a.validations;
  return React__default["default"].createElement("div", __assign({
    className: classnames__default["default"](styles$1.formField, className)
  }, utilsCommons.parseMetadata(metadata)), React__default["default"].createElement(Label, __assign({
    label: label,
    tooltipContent: labelTooltipContent,
    tooltipMouseOutDelay: labelTooltipMouseOutDelay
  }, htmlFor ? {
    htmlFor: htmlFor
  } : {}, {
    hintText: hintText
  })), helperText && React__default["default"].createElement(HelperText, {
    text: helperText
  }), React__default["default"].createElement("div", null, children), React__default["default"].createElement(Validations, {
    id: validationsId,
    validations: validations
  }));
};
var FormField = function (_a) {
  var horizontal = _a.horizontal,
    rest = __rest(_a, ["horizontal"]);
  return horizontal ? React__default["default"].createElement(HorizontalFormField, __assign({}, rest)) : React__default["default"].createElement(VerticalFormField, __assign({}, rest));
};
var styles = {
  "label": "FormFieldView-module__VlMHsYVA__v5-4-62",
  "placeholder": "FormFieldView-module__c3En8i4d__v5-4-62",
  "text": "FormFieldView-module__kam1h4wv__v5-4-62",
  "horizontalFormFieldView": "FormFieldView-module__KMj6MuZy__v5-4-62"
};
var FormFieldView = function (_a) {
  var _b, _c;
  var _d = _a.children,
    children = _d === void 0 ? null : _d,
    _e = _a.className,
    className = _e === void 0 ? '' : _e,
    _f = _a.horizontal,
    horizontal = _f === void 0 ? false : _f,
    _g = _a.metadata,
    metadata = _g === void 0 ? {} : _g,
    _h = _a.placeholder,
    placeholder = _h === void 0 ? '-' : _h,
    label = _a.label;
  return React__default["default"].createElement("div", __assign({
    className: classnames__default["default"](className, (_b = {}, _b[styles.horizontalFormFieldView] = horizontal, _b))
  }, utilsCommons.parseMetadata(metadata)), React__default["default"].createElement(typography.Typography, {
    token: "heading-small",
    component: "div",
    className: styles.label
  }, label), React__default["default"].createElement(typography.Typography, {
    token: "body-large",
    component: "div",
    className: classnames__default["default"]((_c = {}, _c[styles.placeholder] = !children, _c[styles.text] = children, _c))
  }, children || placeholder));
};
var validationStatusOutlines = {
  validating: 'default',
  valid: 'default',
  warning: 'warning',
  invalid: 'error'
};
var validationToSeverityMap = {
  validating: 0,
  valid: 1,
  warning: 2,
  invalid: 3
};
var validationStatusToOutline = function (statuses) {
  if (!statuses || statuses.length === 0) return 'default';
  var highestSeverityStatus = Array.from(new Set(statuses)).sort(function (a, b) {
    return validationToSeverityMap[b] - validationToSeverityMap[a];
  })[0];
  return validationStatusOutlines[highestSeverityStatus];
};
var InputFormFieldWithRef = function (_a, ref) {
  var inputProps = _a.inputProps,
    id = _a.id,
    formFieldProps = __rest(_a, ["inputProps", "id"]);
  var generatedId = utilsHooks.useId('inputFormField-');
  var inputId = id || generatedId;
  var validationsId = "validations-" + inputId;
  return React__default["default"].createElement(FormField, __assign({}, formFieldProps, {
    htmlFor: inputId,
    validationsId: validationsId
  }), React__default["default"].createElement(input.Input, __assign({}, inputProps, {
    id: inputId,
    "aria-describedby": validationsId,
    outline: formFieldProps.validations && validationStatusToOutline(formFieldProps.validations.map(function (x) {
      return x.status;
    })),
    ref: ref
  }, utilsCommons.parseMetadata(utilsCommons.suffixMetadata(formFieldProps.metadata, 'input')))));
};
var InputFormField = React__default["default"].forwardRef(InputFormFieldWithRef);
var SelectFormField = function (_a) {
  var selectProps = _a.selectProps,
    id = _a.id,
    formFieldProps = __rest(_a, ["selectProps", "id"]);
  var generatedId = utilsHooks.useId('selectFormField-');
  var selectId = id || generatedId;
  var validationsId = "validations-" + selectId;
  return React__default["default"].createElement(FormField, __assign({}, formFieldProps, {
    htmlFor: selectId,
    validationsId: validationsId
  }), React__default["default"].createElement(select.Select, __assign({}, selectProps, {
    triggerId: selectId,
    variant: "full-width",
    "aria-describedby": validationsId,
    outline: formFieldProps.validations && validationStatusToOutline(formFieldProps.validations.map(function (x) {
      return x.status;
    }))
  }, utilsCommons.parseMetadata(utilsCommons.suffixMetadata(formFieldProps.metadata, 'select')))));
};
var TextAreaFormFieldWithRef = function (_a, ref) {
  var textAreaProps = _a.textAreaProps,
    id = _a.id,
    formFieldProps = __rest(_a, ["textAreaProps", "id"]);
  var generatedId = utilsHooks.useId('textFormField-');
  var textAreaId = id || generatedId;
  var validationsId = "validations-" + textAreaId;
  return React__default["default"].createElement(FormField, __assign({}, formFieldProps, {
    htmlFor: textAreaId,
    validationsId: validationsId
  }), React__default["default"].createElement(input.TextArea, __assign({}, textAreaProps, {
    id: textAreaId,
    "aria-describedby": validationsId,
    outline: formFieldProps.validations && validationStatusToOutline(formFieldProps.validations.map(function (x) {
      return x.status;
    })),
    ref: ref
  }, utilsCommons.parseMetadata(utilsCommons.suffixMetadata(formFieldProps.metadata, 'textarea')))));
};
var TextAreaFormField = React__default["default"].forwardRef(TextAreaFormFieldWithRef);
exports.FormField = FormField;
exports.FormFieldView = FormFieldView;
exports.InputFormField = InputFormField;
exports.SelectFormField = SelectFormField;
exports.TextAreaFormField = TextAreaFormField;
//# sourceMappingURL=index.js.map
